image: python:3.6

stages: 
  - unit-test
  - acceptance-test
  - analysis

variables:
  PIP_CACHE_DIR: "$CI_PROJECT_DIR/.cache"

cache: 
  paths: 
    - .cache/pip
    - venv

unit test:
  stage: unit-test
  before_script:
  - python -V
  - pip install virtualenv
  - virtualenv venv
  - source venv/bin/activate
  - pip install -r requirements.txt
  script:
  - nosetests --exe --with-coverage --cover-xml --with-xunit
  artifacts:
    paths: 
      - nosetests.xml
      - coverage.xml
    expire_in: 1 week
    reports:
      junit: nosetests.xml

acceptance test: 
  stage: acceptance-test
  before_script:
  - python -V
  - pip install virtualenv
  - virtualenv venv
  - source venv/bin/activate
  - pip install -r requirements.txt
  script: 
  - behave

sonar:
  stage: analysis
  image: mercuriete/sonar-scanner
  script:
  - sonar-scanner -X -Dsonar.host.url=$SONAR_URL -Dsonar.projectKey=$CI_PROJECT_NAME -Dsonar.login=$SONAR_PROJECT_TOKEN -Dsonar.sources=torpydo,tests,features -Dsonar.python.xunit.reportPath=nosetests.xml -Dsonar.python.coverage.reportPaths=coverage.xml

